package es.geeknekodroid.divertiletras;

import java.util.Random;
import java.util.concurrent.TimeUnit;

import android.app.Activity;
import android.content.Intent;
import android.graphics.Typeface;
import android.media.AudioManager;
import android.media.MediaPlayer;
import android.media.SoundPool;
import android.os.Bundle;
import android.os.CountDownTimer;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.TextView;
import es.geeknekodroid.divertiletras.Database.TrainCursor;

public class Mercancia extends Activity {
	public Database db = new Database(this);
	public Integer maxTren, correcta, nivel, sumaPuntos, restaPuntos;
	public Integer nuevaPuntuacion = 0;
	public ImageView tren;
	public Button caja1, caja2, caja3, caja4;
	public TextView puntos;
	TrainCursor c, cTren;
	Typeface font;
	public static PuntuacionMercancia mejorP;
	SoundPool soundPool;
	int sonidoBien, sonidoMal;
	MediaPlayer mp;
	

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_mercancia);

		font = Typeface.createFromAsset(getAssets(), "fonts/pacifico.ttf");
		
		//Efectos de sonido
		soundPool = new SoundPool(10, AudioManager.STREAM_MUSIC, 0);
		sonidoBien = soundPool.load(this, R.raw.johnsonbrandeditingdingdingsmallbell, 1);
		sonidoMal = soundPool.load(this, R.raw.autisticlucarioerror, 1);
		//Musica
		mp = MediaPlayer.create(this, R.raw.monkeysspinningmonkeys);
		mp.start();
		
		mejorP = new PuntuacionMercancia(this);
		
		puntos = (TextView)findViewById(R.id.puntos);
		puntos.setText(nuevaPuntuacion.toString());
		
		//Comprobamos el numero de registros en la base de datos
		cTren = db.getAllTrains();
		maxTren = cTren.getCount();
		cTren.close();

		tren = (ImageView) findViewById(R.id.tren);
		caja1 = (Button) findViewById(R.id.caja1);
		caja1.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				checkOption(0);
			}
		});
		caja2 = (Button) findViewById(R.id.caja2);
		caja2.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				checkOption(1);
			}
		});
		caja3 = (Button) findViewById(R.id.caja3);
		caja3.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				checkOption(2);
			}
		});
		caja4 = (Button) findViewById(R.id.caja4);
		caja4.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				checkOption(3);
			}
		});
		//Se carga un tren elegido de forma aleatoria
		setTrain();
		
		//Se podr jugar durante 2 minutos
		new CountDownTimer(120000, 1000) 
		{
			MyTextView tiempo = (MyTextView)findViewById(R.id.tiempo);
			
			private static final String FORMAT = "%02d:%02d";
			@Override
			public void onTick(long millisUntilFinished) 
			{
				tiempo.setText(""+String.format(FORMAT, TimeUnit.MILLISECONDS.toMinutes(millisUntilFinished),
							   TimeUnit.MILLISECONDS.toSeconds(millisUntilFinished) - 
							   TimeUnit.MINUTES.toSeconds(TimeUnit.MILLISECONDS.toMinutes(millisUntilFinished))));
			}
			
			@Override
			public void onFinish() 
			{
				mercanciaFinish();
			}
		}.start();

	}

	public void setTrain() {
		Integer randomBox;
		Random randomGenerator = new Random();
		int randomTrain = randomGenerator.nextInt(maxTren) + 1;

		c = db.getTrain(randomTrain);
		//Nivel de la palabra
		nivel = c.getColNivel();
		sumaPuntos = nivel*100;
		restaPuntos = nivel*50;
		
		// Imagen tren
		String imagenTren = c.getColPalabra();
		tren.setImageResource(getResources().getIdentifier(imagenTren, null, getPackageName()));
		Log.e("tren", imagenTren);

		// Imagenes cajas
		int[] cajas = { 0, 0, 0, 0 }; // 0 = caja vacia; 1 = caja llena
		String[] letras = {"", "", "", ""};

		// caja1
		do
		{
			randomBox = randomGenerator.nextInt(4);
		} while (cajas[randomBox] == 1);
		cajas[randomBox] = 1;
		correcta = randomBox; //Sera la opcion correcta
		letras[randomBox] = c.getColOpcion1();
		
		// caja2
		do
		{
			randomBox = randomGenerator.nextInt(4);
		} while (cajas[randomBox] == 1);
		cajas[randomBox] = 1;
		letras[randomBox] = c.getColOpcion2();

		// caja3
		do
		{
			randomBox = randomGenerator.nextInt(4);
		} while (cajas[randomBox] == 1);
		cajas[randomBox] = 1;
		letras[randomBox] = c.getColOpcion3();
		
		// caja4
		do 
		{
			randomBox = randomGenerator.nextInt(4);
		} while (cajas[randomBox] == 1);
		cajas[randomBox] = 1;
		letras[randomBox] = c.getColOpcion4();
		
		caja1.setBackgroundResource(getResources().getIdentifier(letras[0], null, getPackageName()));
		caja2.setBackgroundResource(getResources().getIdentifier(letras[1], null, getPackageName()));
		caja3.setBackgroundResource(getResources().getIdentifier(letras[2], null, getPackageName()));
		caja4.setBackgroundResource(getResources().getIdentifier(letras[3], null, getPackageName()));

		c.close();
	}

	public void checkOption(int n) 
	{
		if(n == correcta)
		{
			//Puntuacion actualizada
			soundPool.play(sonidoBien, 1, 1, 1, 0, 1);
			nuevaPuntuacion = nuevaPuntuacion + sumaPuntos;
			puntos.setTextColor(getResources().getColor(R.color.verde));
			puntos.setText(nuevaPuntuacion.toString());
			//Nuevo tren
			setTrain();
		}
		else
		{
			//Puntuacion actualizada
			soundPool.play(sonidoMal, 1, 1, 1, 0, 1);
			int puntuacionNegativa = nuevaPuntuacion - restaPuntos;
			if(puntuacionNegativa > 0)
			{
				nuevaPuntuacion = puntuacionNegativa;
			}
			else
			{
				nuevaPuntuacion = 0;
			}
			puntos.setTextColor(getResources().getColor(R.color.rojo));
			puntos.setText(nuevaPuntuacion.toString());
			//Nuevo tren
			setTrain();
		}
	}

	public void mercanciaFinish()
	{
		//Guardamos la puntuacin si superamos nuestra mejor puntuacin
		int mejorPuntuacion = mejorP.leerPuntuacion();
		if(nuevaPuntuacion > mejorPuntuacion)
		{
			mejorP.guardarPuntuacion(nuevaPuntuacion);
		}
		//Abrimos una nueva actividad y salimos
		Intent i = new Intent(getApplicationContext(), MercanciaEnd.class);
		i.putExtra("Puntuacion", nuevaPuntuacion);
		startActivity(i);
		releaseResources();
		finish();
	}
	
	public void releaseResources()
	{
		if(!c.isClosed())
			c.close();
		if(!cTren.isClosed())
			cTren.close();
		soundPool.release();
		mp.release();
		db.close();
		
	}
}
