package es.geeknekodroid.divertiletras;

import android.content.Context;
import android.content.res.TypedArray;
import android.graphics.Typeface;
import android.util.AttributeSet;
import android.widget.TextView;

public class MyTextView extends TextView 
{
	public MyTextView(Context context, AttributeSet attrs, int defStyle) 
	{
		super(context, attrs, defStyle);
		init(attrs);
	}

	public MyTextView(Context context, AttributeSet attrs) 
	{
		super(context, attrs);
		init(attrs);

	}

	public MyTextView(Context context) 
	{
		super(context);
		init(null);
	}

	private void init(AttributeSet attrs) 
	{
		if (attrs != null) 
		{
			TypedArray a = getContext().obtainStyledAttributes(attrs, R.styleable.MyTextView);
			Typeface myTypeface = Typeface.createFromAsset(getContext().getAssets(), "fonts/pacifico.ttf");
			setTypeface(myTypeface);
			a.recycle();
		}
	}
}