package es.geeknekodroid.divertiletras;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStreamReader;
import java.util.Vector;

import android.content.Context;
import android.util.Log;

public class PuntuacionMercancia 
{
	private static String FICHERO = "puntuaciones.txt";
	private Context context;

	public PuntuacionMercancia(Context context) 
	{
		this.context = context;
	}

	public void guardarPuntuacion(int puntos) 
	{
		try 
		{
			FileOutputStream f = context.openFileOutput(FICHERO, Context.MODE_PRIVATE);
			String texto = String.valueOf(puntos);
			f.write(texto.getBytes());
			f.close();
		} catch (Exception e) {
			Log.e("Divertiletras", e.getMessage(), e);
		}
	}

	public int leerPuntuacion() 
	{
		int puntuacion = 0;
		try 
		{
			FileInputStream f = context.openFileInput(FICHERO);
			BufferedReader entrada = new BufferedReader(new InputStreamReader(f));
			String linea = entrada.readLine();
			if (linea != null) 
			{
				puntuacion = Integer.valueOf(linea);
			}
			f.close();
		} catch (Exception e) {
			Log.e("Divertiletras", e.getMessage(), e);
		}
		return puntuacion;
	}
}